Module SaveToolbars
    ' Save the ToolBar's Button's Visible properties.
    Public Sub SaveToolbar(ByVal client_toolbar As ToolBar, ByVal app_name As String)
        ' Save each button's Visible value.
        For i As Integer = 0 To client_toolbar.Buttons.Count - 1
            SaveSetting(app_name, "ToolBarSettings", _
                i.ToString, client_toolbar.Buttons(i).Visible.ToString)
        Next i
    End Sub

    ' Restore the ToolBar's Button's Visible properties.
    Public Sub RestoreToolbar(ByVal client_toolbar As ToolBar, ByVal app_name As String)
        ' Restore each button's Visible value.
        For i As Integer = 0 To client_toolbar.Buttons.Count - 1
            ' See if this button's Visible value is true.
            ' Note that we use the current value as 
            ' defined by the program at design time
            ' as the default.
            If CBool(GetSetting(app_name, "ToolBarSettings", _
                i.ToString, client_toolbar.Buttons(i).Visible.ToString)) _
            Then
                client_toolbar.Buttons(i).Visible = True
            Else
                client_toolbar.Buttons(i).Visible = False
            End If
        Next i
    End Sub
End Module
