Public Class dlgCustomizeToolBar
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents btnOk As System.Windows.Forms.Button
    Friend WithEvents btnCancel As System.Windows.Forms.Button
    Friend WithEvents tbrButtons As System.Windows.Forms.ToolBar
    Friend WithEvents btnSelectAll As System.Windows.Forms.Button
    Friend WithEvents btnDeselectAll As System.Windows.Forms.Button
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.btnOk = New System.Windows.Forms.Button
        Me.btnCancel = New System.Windows.Forms.Button
        Me.tbrButtons = New System.Windows.Forms.ToolBar
        Me.btnSelectAll = New System.Windows.Forms.Button
        Me.btnDeselectAll = New System.Windows.Forms.Button
        Me.SuspendLayout()
        '
        'btnOk
        '
        Me.btnOk.Anchor = CType((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.btnOk.Location = New System.Drawing.Point(360, 56)
        Me.btnOk.Name = "btnOk"
        Me.btnOk.Size = New System.Drawing.Size(48, 24)
        Me.btnOk.TabIndex = 6
        Me.btnOk.Text = "OK"
        '
        'btnCancel
        '
        Me.btnCancel.Anchor = CType((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.btnCancel.Location = New System.Drawing.Point(360, 88)
        Me.btnCancel.Name = "btnCancel"
        Me.btnCancel.Size = New System.Drawing.Size(48, 24)
        Me.btnCancel.TabIndex = 7
        Me.btnCancel.Text = "Cancel"
        '
        'tbrButtons
        '
        Me.tbrButtons.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.tbrButtons.DropDownArrows = True
        Me.tbrButtons.Location = New System.Drawing.Point(0, 0)
        Me.tbrButtons.Name = "tbrButtons"
        Me.tbrButtons.ShowToolTips = True
        Me.tbrButtons.Size = New System.Drawing.Size(416, 44)
        Me.tbrButtons.TabIndex = 8
        '
        'btnSelectAll
        '
        Me.btnSelectAll.Anchor = System.Windows.Forms.AnchorStyles.Top
        Me.btnSelectAll.Location = New System.Drawing.Point(112, 56)
        Me.btnSelectAll.Name = "btnSelectAll"
        Me.btnSelectAll.Size = New System.Drawing.Size(72, 24)
        Me.btnSelectAll.TabIndex = 9
        Me.btnSelectAll.Text = "Select All"
        '
        'btnDeselectAll
        '
        Me.btnDeselectAll.Anchor = System.Windows.Forms.AnchorStyles.Top
        Me.btnDeselectAll.Location = New System.Drawing.Point(224, 56)
        Me.btnDeselectAll.Name = "btnDeselectAll"
        Me.btnDeselectAll.Size = New System.Drawing.Size(72, 24)
        Me.btnDeselectAll.TabIndex = 10
        Me.btnDeselectAll.Text = "Deselect All"
        '
        'dlgCustomizeToolBar
        '
        Me.AcceptButton = Me.btnOk
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.CancelButton = Me.btnCancel
        Me.ClientSize = New System.Drawing.Size(416, 125)
        Me.Controls.Add(Me.btnDeselectAll)
        Me.Controls.Add(Me.btnSelectAll)
        Me.Controls.Add(Me.tbrButtons)
        Me.Controls.Add(Me.btnCancel)
        Me.Controls.Add(Me.btnOk)
        Me.Name = "dlgCustomizeToolBar"
        Me.Text = "Customize ToolBar"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private m_ClientToolBar As ToolBar = Nothing

    ' Don't let the program show the dialog normally.
    Public Shadows Sub Show()
        Throw New NotSupportedException("Show is not supported. Use the CustomizeToolbar method instead.")
    End Sub
    Public Shadows Sub ShowDialog()
        Throw New NotSupportedException("ShowDialog is not supported. Use the CustomizeToolbar method instead.")
    End Sub

    ' Display the dialog.
    Public Sub CustomizeToolbar(ByVal client_toolbar As ToolBar)
        m_ClientToolBar = client_toolbar

        ' Copy the client ToolBar's buttons.
        tbrButtons.ImageList = client_toolbar.ImageList
        For Each btn As ToolBarButton In client_toolbar.Buttons
            ' Copy this the button.
            Dim new_btn As New ToolBarButton
            new_btn.ImageIndex = btn.ImageIndex
            new_btn.Text = btn.Text
            new_btn.Style = btn.Style
            new_btn.Pushed = btn.Visible
            new_btn.ToolTipText = btn.ToolTipText
            tbrButtons.Buttons.Add(new_btn)
        Next btn

        ' Display the dialog modally.
        MyBase.ShowDialog()
    End Sub

    ' Toggle the button.
    Private Sub tbrSelected_ButtonClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.ToolBarButtonClickEventArgs) Handles tbrButtons.ButtonClick
        e.Button.Pushed = Not e.Button.Pushed
    End Sub

    ' Update the ToolBar.
    Private Sub btnOk_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOk.Click
        ' Examine all buttons.
        For i As Integer = 0 To m_ClientToolBar.Buttons.Count - 1
            m_ClientToolBar.Buttons(i).Visible = tbrButtons.Buttons(i).Pushed
        Next i

        Me.DialogResult = DialogResult.OK
    End Sub

    ' Select all of the buttons.
    Private Sub btnSelectAll_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSelectAll.Click
        ' Skip separators.
        For Each btn As ToolBarButton In tbrButtons.Buttons
            If btn.Style <> ToolBarButtonStyle.Separator Then
                btn.Pushed = True
            End If
        Next btn
    End Sub

    ' Deselect all of the buttons.
    Private Sub btnDeselectAll_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDeselectAll.Click
        ' Skip separators.
        For Each btn As ToolBarButton In tbrButtons.Buttons
            If btn.Style <> ToolBarButtonStyle.Separator Then
                btn.Pushed = False
            End If
        Next btn
    End Sub
End Class
